/*
 * blanco Framework
 * Copyright (C) 2004-2006 IGA Tosiki
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 */
package blanco.commons.util;

import java.io.IOException;
import java.io.StringReader;
import java.io.StringWriter;

/**
 * blanco FrameworkɂAɊւ郆[eBeB܂܂܂B
 * 
 * ƂĂقƂǂ̃\bhstatic\bhƂĒ񋟂܂B
 * 
 * @author IGA Tosiki
 */
public class BlancoStringUtil {
    /**
     * ^ꂽbytez16i\L擾܂BŖ߂܂B
     * 
     * @param arg
     * @return
     */
    public static final String toHexString(final byte[] arg) {
        final StringBuffer buf = new StringBuffer();
        for (int index = 0; index < arg.length; index++) {
            buf.append(toHexString(arg[index]));
        }
        return buf.toString();
    }

    /**
     * ^ꂽbyte16i\L擾܂BŖ߂܂B
     * 
     * @param arg
     * @return
     */
    public static final String toHexString(final byte arg) {
        // ̒lɂ16i\L擾܂B
        String strResult = Integer.toHexString(arg & 0xff);
        for (; strResult.length() < 2;) {
            strResult = "0" + strResult;
        }
        return strResult;
    }

    /**
     * ^ꂽchar16i\Lɕϊ܂BŖ߂܂B
     * 
     * @param arg
     * @return
     */
    public static final String toHexString(final char arg) {
        String strResult = Integer.toHexString(arg);
        for (; strResult.length() < 4;) {
            strResult = "0" + strResult;
        }
        return strResult;
    }

    /**
     * K\Ƃ͊֌WȂ̒us܂B
     * 
     * ̃\bhł java.lang.StringƂ͈قȂ萳K\͊֗^܂B<br>
     * K\@\ĂقȂu̍ۂɗp܂B
     * 
     * @param source
     *            ϊ
     * @param replaceFrom
     *            u
     * @param replaceTo
     *            u̕
     * @return uꂽ
     */
    public static final String replaceAll(final String source,
            final char replaceFrom, final char replaceTo) {
        if (source == null) {
            throw new IllegalArgumentException(
                    "ũ\bhɁAϊƂnull^܂BnullȊO̒l^ĂB");
        }

        try {
            final StringReader reader = new StringReader(source);
            final StringWriter writer = new StringWriter();
            try {
                for (;;) {
                    int iRead = reader.read();
                    if (iRead < 0) {
                        break;
                    }
                    if (iRead == replaceFrom) {
                        iRead = replaceTo;
                    }
                    writer.write(iRead);
                }
                return writer.toString();
            } finally {
                reader.close();
                writer.close();
            }
        } catch (IOException ex) {
            throw new IllegalArgumentException(
                    "ũ\bh̏ɁAz肳ȂO܂Bf܂B" + ex.toString());
        }
    }

    /**
     * ^ꂽnull̏ꍇɁA0̕ւƕϊ܂BŖꍇɂ́Â܂܂̕񂪖߂܂B
     * 
     * null𒷂0̕ɒuꍇɁÃ\bh𗘗p܂B<br>
     * 񏈗̉ߒ null肤̂ ͒0̕Ƃ݂Ȃꍇɂ̃\bh𗘗p邱Ƃz肵܂B
     * 
     * @param originalString
     *            ͕Bnull^ 0̕ɕϊ܂B
     * @return ϊ̕BK nullȊO߂܂B
     */
    public static final String null2Blank(final String originalString) {
        if (originalString == null) {
            // null̏ꍇɂ́A0̕ɒu܂B
            return "";
        }
        // łȂꍇɂ́AƂ̕񂪂̂܂ܖ߂܂B
        return originalString;
    }

    /**
     * ̒擾܂Bnull̏ꍇɂ 0Ƃ݂Ȃ܂B
     * 
     * null肤镶̒擾ꍇɗp邱Ƃz肵Ă܂B
     * 
     * @param sourceString
     *            擾B
     * @return ̒Bnull^ꂽꍇɂ0߂܂B
     */
    public static final int getLengthNullable(final String sourceString) {
        // null^Ă0łƔf܂B
        return null2Blank(sourceString).length();
    }
}
